Subject: Re: a F-RTO question

From: Li Yu <[email-masked]>
Date: Wed, 28 Mar 2012 14:43:10 +0800

于 2012年03月28日 13:35, Yuchung Cheng 写道:
> On Tue, Mar 27, 2012 at 9:08 PM, Li Yu<[email-masked]>  wrote:
>> 于 2012年03月28日 11:49, Chao Pei 写道:
>>
>>>> Hi,
>>>>
>>>>         I have a question about tcp_process_frto(), the below source
>>>> code :
>>>>
>>>> static int tcp_process_frto(struct sock *sk, int flag)
>>>> {
>>>>         .....
>>>>
>>>>         if (!before(tp->snd_una, tp->frto_highmark)) {
>>>>                 tcp_enter_frto_loss(sk, ...);
>>>>                 return 1;
>>>>         }
>>>>
>>>>         .....
>>>>
>>>> }
>>>>
>>>>         As my understanding, the tp->frto_highmark likes tp->high_seq,
>>>> it saves the seqno SND_NXT when a TCP connection enters F-RTO phase,
>>>> is it the variable "recovery" in NewReno? So I think that if snd_una is
>>>> equal with or after frto_highmark, which means peer ack new data, so
>>>> why we enter Loss state here?
>>>>
>>>>         Thanks!
>>>>
>>>> Yu
>>>>
>>>>
>>>
>>> If snd_una advances to frto_highmark, it is likely that the hole was
>>> filled by the retransimitted packet, which means the original packet
>>> was likely to have been lost.
>>> So, we should enter loss state.
>>>
>>
>> I do not agree with it, if snd_una advanced to frto_highmark, which means
>> peer acks whole window of data instead of just one segment, and
>> we can not make sure that reason of peer sends ack is whether it received
>> original segment or retransmitted segment.
>>
>> Even, the reason is latter, it also means the netowrk already is
>> recovered from temporarily congestion or disordered state, so we also should
>> not enter loss state.
> Like you said there is some ambiguity and F-RTO takes the conservative approach.
> You can find answers to your question in RFC 5682  (Section 2.2). Unless the RTO
> is proven to be spurious, TCP should reduce window and performs
> slow-start regardlessly.
> 

I think I got it, if the new ack covers "frto_highmark",
it may mean the fast retransmitted segments are lost likely.

In RFC5682:

   If the first acknowledgment after the RTO retransmission covers the
   "recover" point at algorithm step (2a), there is not enough evidence
   that a non-retransmitted segment has arrived at the receiver after
   the timeout.  This is a common case when a fast retransmission is
   lost and has been retransmitted again after an RTO, while the rest of
   the unacknowledged segments were successfully delivered to the TCP
   receiver before the retransmission timeout.  Therefore, the timeout
   cannot be declared spurious in this case.

And as Chao's words, if the RTO is proven, we should enter
slow-start then.

Thanks!

Yu